# -*- coding: utf-8 -*-

#3a) Considerando un file PDB "pdbfile" che contiene la struttura di una 
# proteina con una sola catena, si scriva una funzione most_common_aa(pdbfile) 
# che restituisca la lista ordinata dei simboli degli amminoacidi (a singola 
# lettera) che compaiono nella struttura primaria con la frequenza più alta.
# La funzione dovrà lanciare l'eccezione ValueError nel caso in cui nel file 
# PDB sia presente più di una catena.

from Bio.PDB.PDBParser import PDBParser
from Bio.PDB.Polypeptide import PPBuilder
       
def most_common_aa(pdbfile):

    struct1=PDBParser().get_structure('CONF1', pdbfile)
    
    nchains1=list(struct1.get_chains())
    if nchains1:
        if len(nchains1)!=1:
            raise ValueError  
    else:
        raise ValueError
        
    ppeps=PPBuilder().build_peptides(struct1)
    
    aaseq=str(ppeps[0].get_sequence())
    
    aacount=dict()
    for r in aaseq:
        try:
            aacount[r]+=1
        except KeyError:
            aacount[r]=1
    maxc=max(aacount.values())
    
    res=[k for k,v in aacount.iteritems() if v==maxc]
    res.sort()
    return res
    